/*
 * Libraries to link to:
 * libcmt.lib kernel32.lib advapi.lib shell32.lib
*/

#ifndef _SERVICE_H
#define _SERVICE_H


#ifdef __cplusplus
extern "C" {
#endif

#include <time.h>
#include <stdio.h>

//////////////////////////////////////////////////////////////////////////////
//// todo: change to desired strings
////
// name of the executable
#define SZAPPNAME            szappname
// internal name of the service
#define SZSERVICENAME        szservicename
// displayed name of the service
#define SZSERVICEDISPLAYNAME szdisplayname
// list of service dependencies - "dep1\0dep2\0\0"
//#define SZDEPENDENCIES "dep1\0dep2\0\0"
#define SZDEPENDENCIES       szdependencies

// default return code when called without parameter
#define RET_DEFAULT 42
// success of installation
#define RET_SUCCESS 0
// default return code when called without parameter
#define RET_ERROR 1
DWORD returnCode; 

int stopport;
BOOL bDebug;
BOOL bCommandLine;
BOOL bCommandLineDebug;
BOOL bService;
BOOL useConsoleHandler;
LPTSTR stopClass;
LPTSTR stopMethod;
LPTSTR stopSignature;
LPTSTR* stopParams;

LPTSTR pauseClass;
LPTSTR pauseMethod;
LPTSTR pauseSignature;
LPTSTR* pauseParams;

LPTSTR contClass;
LPTSTR contMethod;
LPTSTR contSignature;
LPTSTR* contParams;

LPTSTR confirmrunClass;
LPTSTR confirmrunMethod;
LPTSTR confirmrunSignature;
LPTSTR* confirmrunParams;

LPTSTR premainClass;
LPTSTR premainMethod;
LPTSTR premainSignature;
LPTSTR* premainParams;

LPTSTR systemOut;
LPTSTR systemErr;

LPTSTR* exportParams;

BOOL systemOutAppend;
BOOL systemErrAppend;

BOOL interactwithdesktop;

// 0.99d - 19.02.2003 Urs Bloechlinger
BOOL stdOutAppend;
BOOL stdErrAppend;

//jre location in ini file
LPTSTR global_jrePath;
LPTSTR global_jvmtype;

//Allowed JRE startup modes
LPTSTR jreSearchP;
LPTSTR* jreSearch;
BOOL jreSearchRegistry;
BOOL jreSearchLocal;
BOOL jreSearchPath;

BOOL registryfindjre;
BOOL registryfindjdk;
BOOL registryfindazul;
BOOL registryfindoracle;
BOOL registryfindj9;
BOOL registryfindcorretto;
BOOL registryfindadoptopenjdk;

//Allowed JRE versions
LPTSTR jvmversionallowed;
LPTSTR* jreVersions;

//custom registry path to search
LPTSTR customregistrypaths;
LPTSTR* customregistry;

//failure action
SERVICE_FAILURE_ACTIONS failureActions;
SC_ACTION *fAction;

BOOL bPaused;
//p0.99
int	exceptionErrorCode; 
int startdelay;
LPTSTR onExitError;
BOOL breportservicestoppedonmainthreadexit;

// this event is signalled when the
// service should end
//
HANDLE  hServerStopEvent;


//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
VOID ServiceStart(DWORD dwArgc, LPTSTR *lpszArgv);
VOID ServiceStop();
VOID ServicePause();
VOID ServiceContinue();
void init();
CRITICAL_SECTION csLog;
void logToFile( LPTSTR );
void checkHeap();
void logToFileD(size_t);
void logFileExists();
void timestampFile( LPTSTR szPath );
void fileExists( TCHAR szPath[512] );
void getIniFile(LPSTR);
void getParams(int *pargc, LPTSTR** pargv, boolean show, boolean runAsService);
void cleanup();
void redirect_stdxxx();
void getIniDir( LPTSTR szPath , LPTSTR szDrive, size_t driveSize, LPTSTR szDir, size_t dirSize);
size_t JSLGetProfileString( LPTSTR section, LPTSTR name, LPTSTR _default, LPTSTR buffer, size_t bsize, LPTSTR path );
size_t GetRegistryValue( LPTSTR keyname, LPTSTR entry, LPTSTR value, size_t valueSize );
void AddToMessageLog(LPTSTR lpszMsg);
BOOL WINAPI ControlHandler ( DWORD dwCtrlType );
LPTSTR* stringToArray(char* s, char delim );
LPTSTR GetLastErrorText(LPTSTR lpszBuf, DWORD dwSize);
//////////////////////////////////////////////////////////////////////////////
//Compatibility. Allows compiling against VC6
#ifdef VC6
void strcat_s( char* dest, size_t sDest, char* src);
void strcpy_s( char* dest, size_t sDest, char* src);
void localtime_s( struct tm* _tm, time_t* timer );
size_t fopen_s( FILE** pFile, const char* fname, const char* mode );
size_t freopen_s( FILE** pFile, const char* fname, const char* mode, FILE* stream );
int _snprintf_s( char* dest, size_t sDest, size_t count, char* format, char* p1 );
//void _splitpath_s( const char* path, char* drive, size_t sDrive, char* dir, size_t sDir, char* name, size_t sName, char* ext, size_t sExt, );
#endif
//////////////////////////////////////////////////////////////////////////////
//// The following are procedures which
//// may be useful to call within the above procedures,
//// but require no implementation by the user.
//// They are implemented in service.c

//
//  FUNCTION: ReportStatusToSCMgr()
//
//  PURPOSE: Sets the current status of the service and
//           reports it to the Service Control Manager
//
//  PARAMETERS:
//    dwCurrentState - the state of the service
//    dwWin32ExitCode - error code to report
//    dwWaitHint - worst case estimate to next checkpoint
//
//  RETURN VALUE:
//    TRUE  - success 
//    FALSE - failure
//
BOOL ReportStatusToSCMgr(DWORD dwCurrentState, DWORD dwWin32ExitCode, DWORD dwWaitHint);

//
//  FUNCTION: AddToMessageLog(LPTSTR lpszMsg)
//
//  PURPOSE: Allows any thread to log an error message
//
//  PARAMETERS:
//    lpszMsg - text for message
//
//  RETURN VALUE:
//    none
//
void AddToMessageLog(LPTSTR lpszMsg);
//////////////////////////////////////////////////////////////////////////////


#ifdef __cplusplus
}
#endif

#endif
